diff --git a/lib/structure.c b/lib/structure.c
index 27fbfe3..73ae311 100644
--- a/lib/structure.c
+++ b/lib/structure.c
@@ -94,7 +94,7 @@ _asn1_create_static_structure (asn1_node pointer, char *output_file_name,
   fprintf (file, "# include \"config.h\"\n");
   fprintf (file, "#endif\n\n");
 
-  fprintf (file, "#include <libtasn1.h>\n\n");
+  fprintf (file, "#include <libtasn1-internal.h>\n\n");
 
   fprintf (file, "const asn1_static_node %s[] = {\n", vector_name);
 
@@ -174,8 +174,8 @@ _asn1_create_static_structure (asn1_node pointer, char *output_file_name,
  *   %ASN1_ARRAY_ERROR if the array pointed by @array is wrong.
  **/
 int
-asn1_array2tree (const asn1_static_node * array, asn1_node * definitions,
-		 char *errorDescription)
+asn1_internal_array2tree (const asn1_static_node * array, asn1_node * definitions,
+			  char *errorDescription)
 {
   asn1_node p, p_last = NULL;
   unsigned long k;
@@ -285,9 +285,9 @@ asn1_array2tree (const asn1_static_node * array, asn1_node * definitions,
  *   *@structure was NULL.
  **/
 int
-asn1_delete_structure (asn1_node * structure)
+asn1_internal_delete_structure (asn1_node * structure)
 {
-  return asn1_delete_structure2(structure, 0);
+  return asn1_internal_delete_structure2(structure, 0);
 }
 
 /**
@@ -302,7 +302,7 @@ asn1_delete_structure (asn1_node * structure)
  *   *@structure was NULL.
  **/
 int
-asn1_delete_structure2 (asn1_node * structure, unsigned int flags)
+asn1_internal_delete_structure2 (asn1_node * structure, unsigned int flags)
 {
   asn1_node p, p2, p3;
 
@@ -366,11 +366,11 @@ asn1_delete_structure2 (asn1_node * structure, unsigned int flags)
  *   the @element_name was not found.
  **/
 int
-asn1_delete_element (asn1_node structure, const char *element_name)
+asn1_internal_delete_element (asn1_node structure, const char *element_name)
 {
   asn1_node p2, p3, source_node;
 
-  source_node = asn1_find_node (structure, element_name);
+  source_node = asn1_internal_find_node (structure, element_name);
 
   if (source_node == NULL)
     return ASN1_ELEMENT_NOT_FOUND;
@@ -388,7 +388,7 @@ asn1_delete_element (asn1_node structure, const char *element_name)
   else
     _asn1_set_right (p3, p2);
 
-  return asn1_delete_structure (&source_node);
+  return asn1_internal_delete_structure (&source_node);
 }
 
 asn1_node
@@ -454,7 +454,7 @@ _asn1_copy_structure2 (asn1_node root, const char *source_name)
 {
   asn1_node source_node;
 
-  source_node = asn1_find_node (root, source_name);
+  source_node = asn1_internal_find_node (root, source_name);
 
   return _asn1_copy_structure3 (source_node);
 
@@ -509,7 +509,7 @@ _asn1_type_choice_config (asn1_node node)
 		{
 		  p3 = p2->right;
 		  if (type_field (p2->type) == ASN1_ETYPE_TAG)
-		    asn1_delete_structure (&p2);
+		    asn1_internal_delete_structure (&p2);
 		  p2 = p3;
 		}
 	    }
@@ -670,8 +670,8 @@ _asn1_expand_identifier (asn1_node * node, asn1_node root)
  *   @source_name is not known.
  **/
 int
-asn1_create_element (asn1_node definitions, const char *source_name,
-		     asn1_node * element)
+asn1_internal_create_element (asn1_node definitions, const char *source_name,
+			      asn1_node * element)
 {
   asn1_node dest_node;
   int res;
@@ -705,8 +705,8 @@ asn1_create_element (asn1_node definitions, const char *source_name,
  * from the @name element inside the structure @structure.
  **/
 void
-asn1_print_structure (FILE * out, asn1_node structure, const char *name,
-		      int mode)
+asn1_internal_print_structure (FILE * out, asn1_node structure, const char *name,
+			       int mode)
 {
   asn1_node p, root;
   int k, indent = 0, len, len2, len3;
@@ -714,7 +714,7 @@ asn1_print_structure (FILE * out, asn1_node structure, const char *name,
   if (out == NULL)
     return;
 
-  root = asn1_find_node (structure, name);
+  root = asn1_internal_find_node (structure, name);
 
   if (root == NULL)
     return;
@@ -826,7 +826,7 @@ asn1_print_structure (FILE * out, asn1_node structure, const char *name,
 	      if (p->value)
 		{
 		  len2 = -1;
-		  len = asn1_get_length_der (p->value, p->value_len, &len2);
+		  len = asn1_internal_get_length_der (p->value, p->value_len, &len2);
 		  fprintf (out, "  value:0x");
 		  if (len > 0)
 		    for (k = 0; k < len; k++)
@@ -837,7 +837,7 @@ asn1_print_structure (FILE * out, asn1_node structure, const char *name,
 	      if (p->value)
 		{
 		  len2 = -1;
-		  len = asn1_get_length_der (p->value, p->value_len, &len2);
+		  len = asn1_internal_get_length_der (p->value, p->value_len, &len2);
 		  fprintf (out, "  value:0x");
 		  if (len > 0)
 		    for (k = 0; k < len; k++)
@@ -857,7 +857,7 @@ asn1_print_structure (FILE * out, asn1_node structure, const char *name,
 	      if (p->value)
 		{
 		  len2 = -1;
-		  len = asn1_get_length_der (p->value, p->value_len, &len2);
+		  len = asn1_internal_get_length_der (p->value, p->value_len, &len2);
 		  if (len > 0)
 		    {
 		      fprintf (out, "  value(%i):",
@@ -887,7 +887,7 @@ asn1_print_structure (FILE * out, asn1_node structure, const char *name,
 	      if (p->value)
 		{
 		  len2 = -1;
-		  len = asn1_get_length_der (p->value, p->value_len, &len2);
+		  len = asn1_internal_get_length_der (p->value, p->value_len, &len2);
 		  fprintf (out, "  value:");
 		  if (len > 0)
 		    for (k = 0; k < len; k++)
@@ -899,7 +899,7 @@ asn1_print_structure (FILE * out, asn1_node structure, const char *name,
 	      if (p->value)
 		{
 		  len2 = -1;
-		  len = asn1_get_length_der (p->value, p->value_len, &len2);
+		  len = asn1_internal_get_length_der (p->value, p->value_len, &len2);
 		  fprintf (out, "  value:");
 		  if (len > 0)
 		    for (k = 0; k < len; k++)
@@ -914,7 +914,7 @@ asn1_print_structure (FILE * out, asn1_node structure, const char *name,
 	      if (p->value)
 		{
 		  len3 = -1;
-		  len2 = asn1_get_length_der (p->value, p->value_len, &len3);
+		  len2 = asn1_internal_get_length_der (p->value, p->value_len, &len3);
 		  fprintf (out, "  value:");
 		  if (len2 > 0)
 		    for (k = 0; k < len2; k++)
@@ -1047,7 +1047,7 @@ asn1_print_structure (FILE * out, asn1_node structure, const char *name,
  *   @name is not known, %ASN1_GENERIC_ERROR if pointer @num is %NULL.
  **/
 int
-asn1_number_of_elements (asn1_node element, const char *name, int *num)
+asn1_internal_number_of_elements (asn1_node element, const char *name, int *num)
 {
   asn1_node node, p;
 
@@ -1056,7 +1056,7 @@ asn1_number_of_elements (asn1_node element, const char *name, int *num)
 
   *num = 0;
 
-  node = asn1_find_node (element, name);
+  node = asn1_internal_find_node (element, name);
   if (node == NULL)
     return ASN1_ELEMENT_NOT_FOUND;
 
@@ -1085,7 +1085,7 @@ asn1_number_of_elements (asn1_node element, const char *name, int *num)
  *   the OID.
  **/
 const char *
-asn1_find_structure_from_oid (asn1_node definitions, const char *oidValue)
+asn1_internal_find_structure_from_oid (asn1_node definitions, const char *oidValue)
 {
   char name[2 * ASN1_MAX_NAME_SIZE + 1];
   char value[ASN1_MAX_NAME_SIZE];
@@ -1109,7 +1109,7 @@ asn1_find_structure_from_oid (asn1_node definitions, const char *oidValue)
           snprintf(name, sizeof(name), "%s.%s", definitionsName, p->name);
 
 	  len = ASN1_MAX_NAME_SIZE;
-	  result = asn1_read_value (definitions, name, value, &len);
+	  result = asn1_internal_read_value (definitions, name, value, &len);
 
 	  if ((result == ASN1_SUCCESS) && (!strcmp (oidValue, value)))
 	    {
@@ -1138,8 +1138,8 @@ asn1_find_structure_from_oid (asn1_node definitions, const char *oidValue)
  * Returns: Return %ASN1_SUCCESS on success.
  **/
 int
-asn1_copy_node (asn1_node dst, const char *dst_name,
-		asn1_node src, const char *src_name)
+asn1_internal_copy_node (asn1_node dst, const char *dst_name,
+			 asn1_node src, const char *src_name)
 {
 /* FIXME: rewrite using copy_structure().
  * It seems quite hard to do.
@@ -1149,7 +1149,7 @@ asn1_copy_node (asn1_node dst, const char *dst_name,
   void *data = NULL;
   int size = 0;
 
-  result = asn1_der_coding (src, src_name, NULL, &size, NULL);
+  result = asn1_internal_der_coding (src, src_name, NULL, &size, NULL);
   if (result != ASN1_MEM_ERROR)
     return result;
 
@@ -1157,21 +1157,21 @@ asn1_copy_node (asn1_node dst, const char *dst_name,
   if (data == NULL)
     return ASN1_MEM_ERROR;
 
-  result = asn1_der_coding (src, src_name, data, &size, NULL);
+  result = asn1_internal_der_coding (src, src_name, data, &size, NULL);
   if (result != ASN1_SUCCESS)
     {
       free (data);
       return result;
     }
 
-  dst_node = asn1_find_node (dst, dst_name);
+  dst_node = asn1_internal_find_node (dst, dst_name);
   if (dst_node == NULL)
     {
       free (data);
       return ASN1_ELEMENT_NOT_FOUND;
     }
 
-  result = asn1_der_decoding (&dst_node, data, size, NULL);
+  result = asn1_internal_der_decoding (&dst_node, data, size, NULL);
 
   free (data);
 
diff --git a/lib/version.c b/lib/version.c
index 25f8a8f..0c09525 100644
--- a/lib/version.c
+++ b/lib/version.c
@@ -25,7 +25,7 @@
 
 #include <string.h>		/* for strverscmp */
 
-#include "libtasn1.h"
+#include "libtasn1-internal.h"
 
 /**
  * asn1_check_version:
@@ -42,7 +42,7 @@
  *   run-time library does not meet the required version number.
  */
 const char *
-asn1_check_version (const char *req_version)
+asn1_internal_check_version (const char *req_version)
 {
   if (!req_version || strverscmp (req_version, ASN1_VERSION) <= 0)
     return ASN1_VERSION;
diff --git a/src/asn1Coding.c b/src/asn1Coding.c
index 650e817..93f75d2 100644
--- a/src/asn1Coding.c
+++ b/src/asn1Coding.c
@@ -26,7 +26,7 @@
 #include <unistd.h>
 #include <getopt.h>
 
-#include <libtasn1.h>
+#include <libtasn1-internal.h>
 
 #include <progname.h>
 #include <version-etc.h>
@@ -206,7 +206,7 @@ main (int argc, char *argv[])
   strcpy (inputFileAssignmentName, argv[optind + 1]);
 
   asn1_result =
-    asn1_parser2tree (inputFileAsnName, &definitions, errorDescription);
+    asn1_internal_parser2tree (inputFileAsnName, &definitions, errorDescription);
 
   switch (asn1_result)
     {
@@ -222,7 +222,7 @@ main (int argc, char *argv[])
       fprintf (stderr, "asn1Coding: %s\n", errorDescription);
       break;
     default:
-      fprintf (stderr, "libtasn1 ERROR: %s\n", asn1_strerror (asn1_result));
+      fprintf (stderr, "libtasn1 ERROR: %s\n", asn1_internal_strerror (asn1_result));
     }
 
   if (asn1_result != ASN1_SUCCESS)
@@ -253,18 +253,18 @@ main (int argc, char *argv[])
       fprintf (stderr, "var=%s, value=%s\n", varName, value);
       if (structure == NULL)
 	{
-	  asn1_result = asn1_create_element (definitions, value, &structure);
+	  asn1_result = asn1_internal_create_element (definitions, value, &structure);
 	}
       else
-	asn1_result = asn1_write_value (structure, varName, value, 0);
+	asn1_result = asn1_internal_write_value (structure, varName, value, 0);
 
       if (asn1_result != ASN1_SUCCESS)
 	{
 	  fprintf (stderr, "libtasn1 ERROR: %s\n",
-		   asn1_strerror (asn1_result));
+		   asn1_internal_strerror (asn1_result));
 
-	  asn1_delete_structure (&definitions);
-	  asn1_delete_structure (&structure);
+	  asn1_internal_delete_structure (&definitions);
+	  asn1_internal_delete_structure (&structure);
 
 	  free (inputFileAsnName);
 	  free (inputFileAssignmentName);
@@ -281,26 +281,26 @@ main (int argc, char *argv[])
   fclose (inputFile);
 
   putc ('\n', stderr);
-  asn1_print_structure (stderr, structure, "", ASN1_PRINT_NAME_TYPE_VALUE);
+  asn1_internal_print_structure (stderr, structure, "", ASN1_PRINT_NAME_TYPE_VALUE);
 
   der_len = 0;
-  asn1_result = asn1_der_coding (structure, "", der, &der_len,
+  asn1_result = asn1_internal_der_coding (structure, "", der, &der_len,
 				 errorDescription);
   if (asn1_result == ASN1_MEM_ERROR)
     {
       der = malloc (der_len);
-      asn1_result = asn1_der_coding (structure, "", der, &der_len,
+      asn1_result = asn1_internal_der_coding (structure, "", der, &der_len,
 				     errorDescription);
     }
-  fprintf (stderr, "\nCoding: %s\n\n", asn1_strerror (asn1_result));
+  fprintf (stderr, "\nCoding: %s\n\n", asn1_internal_strerror (asn1_result));
   if (asn1_result != ASN1_SUCCESS)
     {
       fprintf (stderr, "asn1Coding: %s\n", errorDescription);
 
       free (der);
 
-      asn1_delete_structure (&definitions);
-      asn1_delete_structure (&structure);
+      asn1_internal_delete_structure (&definitions);
+      asn1_internal_delete_structure (&structure);
 
       free (inputFileAsnName);
       free (inputFileAssignmentName);
@@ -314,8 +314,8 @@ main (int argc, char *argv[])
     fprintf (stderr, "%02x ", der[k]);
   fputs ("\n-----------------\n", stderr);
 
-  asn1_delete_structure (&definitions);
-  asn1_delete_structure (&structure);
+  asn1_internal_delete_structure (&definitions);
+  asn1_internal_delete_structure (&structure);
 
   if (!checkSyntaxOnly)
     {
diff --git a/src/asn1Decoding.c b/src/asn1Decoding.c
index 5649990..2b7ab43 100644
--- a/src/asn1Decoding.c
+++ b/src/asn1Decoding.c
@@ -26,7 +26,7 @@
 #include <unistd.h>
 #include <getopt.h>
 
-#include <libtasn1.h>
+#include <libtasn1-internal.h>
 
 #include <progname.h>
 #include <version-etc.h>
@@ -140,7 +140,7 @@ main (int argc, char *argv[])
   strcpy (typeName, argv[optind + 2]);
 
   asn1_result =
-    asn1_parser2tree (inputFileAsnName, &definitions, errorDescription);
+    asn1_internal_parser2tree (inputFileAsnName, &definitions, errorDescription);
 
   switch (asn1_result)
     {
@@ -156,7 +156,7 @@ main (int argc, char *argv[])
       fprintf (stderr, "asn1Decoding: %s\n", errorDescription);
       break;
     default:
-      fprintf (stderr, "libtasn1 ERROR: %s\n", asn1_strerror (asn1_result));
+      fprintf (stderr, "libtasn1 ERROR: %s\n", asn1_internal_strerror (asn1_result));
     }
 
   if (asn1_result != ASN1_SUCCESS)
@@ -178,7 +178,7 @@ main (int argc, char *argv[])
     {
       fprintf (stderr, "asn1Decoding: could not read '%s'\n",
 	       inputFileDerName);
-      asn1_delete_structure (&definitions);
+      asn1_internal_delete_structure (&definitions);
 
       free (inputFileAsnName);
       free (inputFileDerName);
@@ -204,7 +204,7 @@ main (int argc, char *argv[])
 
   if (decode (definitions, typeName, der, der_len, benchmark) != ASN1_SUCCESS)
     {
-      asn1_delete_structure (&definitions);
+      asn1_internal_delete_structure (&definitions);
       free (inputFileAsnName);
       free (inputFileDerName);
       free (typeName);
@@ -212,7 +212,7 @@ main (int argc, char *argv[])
       exit (1);
     }
 
-  asn1_delete_structure (&definitions);
+  asn1_internal_delete_structure (&definitions);
 
   free (der);
 
@@ -235,38 +235,38 @@ simple_decode (asn1_node definitions, const char *typeName, void *der,
   asn1_node structure = NULL;
   char errorDescription[ASN1_MAX_ERROR_DESCRIPTION_SIZE];
 
-  asn1_result = asn1_create_element (definitions, typeName, &structure);
+  asn1_result = asn1_internal_create_element (definitions, typeName, &structure);
 
-  /* asn1_print_structure(stdout,structure,"",ASN1_PRINT_ALL); */
+  /* asn1_internal_print_structure(stdout,structure,"",ASN1_PRINT_ALL); */
 
 
   if (asn1_result != ASN1_SUCCESS)
     {
       fprintf (stderr, "Structure creation: %s\n",
-	       asn1_strerror (asn1_result));
-      asn1_delete_structure (&structure);
+	       asn1_internal_strerror (asn1_result));
+      asn1_internal_delete_structure (&structure);
       return asn1_result;
     }
 
   asn1_result =
-    asn1_der_decoding (&structure, der, der_len, errorDescription);
+    asn1_internal_der_decoding (&structure, der, der_len, errorDescription);
 
   if (!benchmark)
-    fprintf (stderr, "\nDecoding: %s\n", asn1_strerror (asn1_result));
+    fprintf (stderr, "\nDecoding: %s\n", asn1_internal_strerror (asn1_result));
   if (asn1_result != ASN1_SUCCESS)
     {
       fprintf (stderr, "asn1Decoding: %s\n", errorDescription);
-      asn1_delete_structure (&structure);
+      asn1_internal_delete_structure (&structure);
       return asn1_result;
     }
 
   if (!benchmark)
     {
       fprintf (stderr, "\nDECODING RESULT:\n");
-      asn1_print_structure (stdout, structure, "",
-			    ASN1_PRINT_NAME_TYPE_VALUE);
+      asn1_internal_print_structure (stdout, structure, "",
+				     ASN1_PRINT_NAME_TYPE_VALUE);
     }
-  asn1_delete_structure (&structure);
+  asn1_internal_delete_structure (&structure);
   return ASN1_SUCCESS;
 }
 
diff --git a/src/asn1Parser.c b/src/asn1Parser.c
index 7a3ae67..bd49550 100644
--- a/src/asn1Parser.c
+++ b/src/asn1Parser.c
@@ -26,7 +26,7 @@
 #include <unistd.h>
 #include <getopt.h>
 
-#include <libtasn1.h>
+#include <libtasn1-internal.h>
 
 #include <progname.h>
 #include <version-etc.h>
@@ -159,13 +159,13 @@ main (int argc, char *argv[])
   if (checkSyntaxOnly == 1)
     {
       parse_result =
-	asn1_parser2tree (inputFileName, &pointer, errorDescription);
-      asn1_delete_structure (&pointer);
+	asn1_internal_parser2tree (inputFileName, &pointer, errorDescription);
+      asn1_internal_delete_structure (&pointer);
     }
   else				/* C VECTOR CREATION */
-    parse_result = asn1_parser2array (inputFileName,
-				      outputFileName, vectorName,
-				      errorDescription);
+    parse_result = asn1_internal_parser2array (inputFileName,
+					       outputFileName, vectorName,
+					       errorDescription);
 
   switch (parse_result)
     {
@@ -181,7 +181,7 @@ main (int argc, char *argv[])
       fprintf (stderr, "asn1Parser: %s\n", errorDescription);
       break;
     default:
-      fprintf (stderr, "libtasn1 ERROR: %s\n", asn1_strerror (parse_result));
+      fprintf (stderr, "libtasn1 ERROR: %s\n", asn1_internal_strerror (parse_result));
     }
 
 
diff --git a/tests/Test_choice.c b/tests/Test_choice.c
index 07da57e..1e9384f 100644
--- a/tests/Test_choice.c
+++ b/tests/Test_choice.c
@@ -1,6 +1,6 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <libtasn1.h>
+#include <libtasn1-internal.h>
 
 int
 main (int argc, char** argv)
@@ -13,59 +13,59 @@ main (int argc, char** argv)
   int data_size = sizeof (data);
 
   /* Encode */
-  result = asn1_parser2tree ("choice.asn", &definitions, errorDescription);
+  result = asn1_internal_parser2tree ("choice.asn", &definitions, errorDescription);
   if (result != ASN1_SUCCESS)
     {
       printf ("error in %d\n", __LINE__);
       exit (1);
     }
 
-  result = asn1_create_element (definitions, "TEST.Choice0", &node1);
+  result = asn1_internal_create_element (definitions, "TEST.Choice0", &node1);
   if (result != ASN1_SUCCESS)
     {
       printf ("error in %d\n", __LINE__);
       exit (1);
     }
 
-  result = asn1_write_value (node1, "", "choice1", 1);
+  result = asn1_internal_write_value (node1, "", "choice1", 1);
   if (result != ASN1_SUCCESS)
     {
       printf ("error in %d\n", __LINE__);
       exit (1);
     }
 
-  result = asn1_write_value (node1, "choice1", "choice2", 1);
+  result = asn1_internal_write_value (node1, "choice1", "choice2", 1);
   if (result != ASN1_SUCCESS)
     {
       printf ("error in %d\n", __LINE__);
       exit (1);
     }
 
-  result = asn1_write_value (node1, "choice1.choice2", "int1", 1);
+  result = asn1_internal_write_value (node1, "choice1.choice2", "int1", 1);
   if (result != ASN1_SUCCESS)
     {
       printf ("error in %d\n", __LINE__);
       exit (1);
     }
 
-  result = asn1_write_value (node1, "choice1.choice2.int1", "1234", 0);
+  result = asn1_internal_write_value (node1, "choice1.choice2.int1", "1234", 0);
   if (result != ASN1_SUCCESS)
     {
       printf ("error in %d\n", __LINE__);
       exit (1);
     }
 
-  result = asn1_der_coding (node1, "", data, &data_size, errorDescription);
+  result = asn1_internal_der_coding (node1, "", data, &data_size, errorDescription);
   if (result != ASN1_SUCCESS)
     {
       printf ("error in %d\n", __LINE__);
       exit (1);
     }
 
-  asn1_delete_structure (&node1);
+  asn1_internal_delete_structure (&node1);
 
   /* Decode */
-  result = asn1_create_element (definitions, "TEST.Choice0", &node2);
+  result = asn1_internal_create_element (definitions, "TEST.Choice0", &node2);
   if (result != ASN1_SUCCESS)
     {
       printf ("error in %d\n", __LINE__);
@@ -79,15 +79,15 @@ main (int argc, char** argv)
   printf ("\n");
 #endif
 
-  result = asn1_der_decoding (&node2, data, data_size, errorDescription);
+  result = asn1_internal_der_decoding (&node2, data, data_size, errorDescription);
   if (result != ASN1_SUCCESS)
     {
       printf ("error in %d\n", __LINE__);
       exit (1);
     }
 
-  asn1_delete_structure (&node2);
-  asn1_delete_structure (&definitions);
+  asn1_internal_delete_structure (&node2);
+  asn1_internal_delete_structure (&definitions);
 
   return 0;
 }
diff --git a/tests/Test_encdec.c b/tests/Test_encdec.c
index 363f2ff..900b704 100644
--- a/tests/Test_encdec.c
+++ b/tests/Test_encdec.c
@@ -32,7 +32,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
-#include "libtasn1.h"
+#include "libtasn1-internal.h"
 
 
 
@@ -70,14 +70,14 @@ main (int argc, char *argv[])
     }
 
   /* Check version */
-  if (asn1_check_version ("0.3.3") == NULL)
+  if (asn1_internal_check_version ("0.3.3") == NULL)
     printf ("\nLibrary version check ERROR:\n actual version: %s\n\n",
-	    asn1_check_version (NULL));
+	    asn1_internal_check_version (NULL));
 
-  result = asn1_parser2tree (treefile, &definitions, errorDescription);
+  result = asn1_internal_parser2tree (treefile, &definitions, errorDescription);
   if (result != ASN1_SUCCESS)
     {
-      asn1_perror (result);
+      asn1_internal_perror (result);
       printf ("ErrorDescription = %s\n\n", errorDescription);
       exit (1);
     }
@@ -100,27 +100,27 @@ main (int argc, char *argv[])
   fclose (fd);
 
   result =
-    asn1_create_element (definitions, "PKIX1.CertificateList", &asn1_element);
+    asn1_internal_create_element (definitions, "PKIX1.CertificateList", &asn1_element);
   if (result != ASN1_SUCCESS)
     {
-      asn1_perror (result);
+      asn1_internal_perror (result);
       printf ("Cannot create CRL element\n");
       exit (1);
     }
 
-  result = asn1_der_decoding (&asn1_element, buffer, size, errorDescription);
+  result = asn1_internal_der_decoding (&asn1_element, buffer, size, errorDescription);
   if (result != ASN1_SUCCESS)
     {
-      asn1_perror (result);
+      asn1_internal_perror (result);
       printf ("Cannot decode DER data (size %ld)\n", (long) size);
       exit (1);
     }
 
   size2 = sizeof(buffer2);
-  result = asn1_der_coding (asn1_element, "", buffer2, &size2, NULL);
+  result = asn1_internal_der_coding (asn1_element, "", buffer2, &size2, NULL);
   if (result != ASN1_SUCCESS)
     {
-      asn1_perror (result);
+      asn1_internal_perror (result);
       printf ("Cannot encode data (size %ld)\n", (long) size);
       exit (1);
     }
@@ -132,8 +132,8 @@ main (int argc, char *argv[])
     }
 
   /* Clear the definition structures */
-  asn1_delete_structure (&definitions);
-  asn1_delete_structure (&asn1_element);
+  asn1_internal_delete_structure (&definitions);
+  asn1_internal_delete_structure (&asn1_element);
 
   if (out != stdout)
     fclose (out);
diff --git a/tests/Test_encoding.c b/tests/Test_encoding.c
index 7d3266c..fdcb08d 100644
--- a/tests/Test_encoding.c
+++ b/tests/Test_encoding.c
@@ -26,7 +26,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
-#include "libtasn1.h"
+#include "libtasn1-internal.h"
 
 
 unsigned char data[256];
@@ -56,79 +56,79 @@ main (int argc, char *argv[])
     }
 
   /* Check version */
-  if (asn1_check_version ("0.3.3") == NULL)
+  if (asn1_internal_check_version ("0.3.3") == NULL)
     printf ("\nLibrary version check ERROR:\n actual version: %s\n\n",
-	    asn1_check_version (NULL));
+	    asn1_internal_check_version (NULL));
 
-  result = asn1_parser2tree (treefile, &definitions, errorDescription);
+  result = asn1_internal_parser2tree (treefile, &definitions, errorDescription);
 
   if (result != ASN1_SUCCESS)
     {
-      asn1_perror (result);
+      asn1_internal_perror (result);
       printf ("ErrorDescription = %s\n\n", errorDescription);
       exit (1);
     }
 
-  result = asn1_create_element (definitions, "TEST_TREE.Koko", &asn1_element);
+  result = asn1_internal_create_element (definitions, "TEST_TREE.Koko", &asn1_element);
   if (result != ASN1_SUCCESS)
     {
       fprintf (stderr, "asn1_create_element(): ");
-      asn1_perror (result);
+      asn1_internal_perror (result);
       exit (1);
     }
 
-  result = asn1_write_value (asn1_element, "seqint", "NEW", 1);
+  result = asn1_internal_write_value (asn1_element, "seqint", "NEW", 1);
   if (result != ASN1_SUCCESS)
     {
       fprintf (stderr, "asn1_write_value(): seqint ");
-      asn1_perror (result);
+      asn1_internal_perror (result);
       exit (1);
     }
 
-  result = asn1_write_value (asn1_element, "seqint.?LAST", "1234", 0);
+  result = asn1_internal_write_value (asn1_element, "seqint.?LAST", "1234", 0);
   if (result != ASN1_SUCCESS)
     {
       fprintf (stderr, "asn1_write_value(): seqint.?LAST ");
-      asn1_perror (result);
+      asn1_internal_perror (result);
       exit (1);
     }
 
-  result = asn1_write_value (asn1_element, "int", "\x0f\xff\x01", 3);
+  result = asn1_internal_write_value (asn1_element, "int", "\x0f\xff\x01", 3);
   if (result != ASN1_SUCCESS)
     {
       fprintf (stderr, "asn1_write_value(): int ");
-      asn1_perror (result);
+      asn1_internal_perror (result);
       exit (1);
     }
 
-  result = asn1_write_value (asn1_element, "str", "string", 6);
+  result = asn1_internal_write_value (asn1_element, "str", "string", 6);
   if (result != ASN1_SUCCESS)
     {
       fprintf (stderr, "asn1_write_value(): str ");
-      asn1_perror (result);
+      asn1_internal_perror (result);
       exit (1);
     }
 
   /* Clear the definition structures */
-  asn1_delete_structure (&definitions);
+  asn1_internal_delete_structure (&definitions);
 
-  result = asn1_der_coding (asn1_element, "", data, &data_size, NULL);
+  result = asn1_internal_der_coding (asn1_element, "", data, &data_size, NULL);
   if (result != ASN1_SUCCESS)
     {
       fprintf (stderr, "Encoding error.\n");
-      asn1_perror (result);
+      asn1_internal_perror (result);
       exit (1);
     }
 
-  result = asn1_der_decoding (&asn1_element, data, data_size, NULL);
+  result = asn1_internal_der_decoding (&asn1_element, data, data_size, NULL);
   if (result != ASN1_SUCCESS)
     {
       fprintf (stderr, "Decoding error.\n");
-      asn1_perror (result);
+      asn1_internal_perror (result);
       exit (1);
     }
 
-  asn1_delete_structure (&asn1_element);
+  asn1_internal_delete_structure (&asn1_element);
 
   if (verbose)
     printf ("Success\n");
diff --git a/tests/Test_errors.c b/tests/Test_errors.c
index 35771b0..e916294 100644
--- a/tests/Test_errors.c
+++ b/tests/Test_errors.c
@@ -18,7 +18,7 @@
  *
  */
 
-#include "libtasn1.h"
+#include "libtasn1-internal.h"
 
 int
 main (int argc, char *argv[])
@@ -32,9 +32,9 @@ main (int argc, char *argv[])
 
   do
     {
-      errstr = asn1_strerror (ec);
+      errstr = asn1_internal_strerror (ec);
       if (verbose != 0)
-	asn1_perror (ec);
+	asn1_internal_perror (ec);
       ec++;
     }
   while (errstr);
diff --git a/tests/Test_indefinite.c b/tests/Test_indefinite.c
index c1613ef..e69d718 100644
--- a/tests/Test_indefinite.c
+++ b/tests/Test_indefinite.c
@@ -32,7 +32,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
-#include "libtasn1.h"
+#include "libtasn1-internal.h"
 
 
 
@@ -68,14 +68,14 @@ main (int argc, char *argv[])
     }
 
   /* Check version */
-  if (asn1_check_version ("0.2.11") == NULL)
+  if (asn1_internal_check_version ("0.2.11") == NULL)
     printf ("\nLibrary version check ERROR:\n actual version: %s\n\n",
-	    asn1_check_version (NULL));
+	    asn1_internal_check_version (NULL));
 
-  result = asn1_parser2tree (treefile, &definitions, errorDescription);
+  result = asn1_internal_parser2tree (treefile, &definitions, errorDescription);
   if (result != ASN1_SUCCESS)
     {
-      asn1_perror (result);
+      asn1_internal_perror (result);
       printf ("ErrorDescription = %s\n\n", errorDescription);
       exit (1);
     }
@@ -98,25 +98,25 @@ main (int argc, char *argv[])
   fclose (fd);
 
   result =
-    asn1_create_element (definitions, "PKIX1.pkcs-12-PFX", &asn1_element);
+    asn1_internal_create_element (definitions, "PKIX1.pkcs-12-PFX", &asn1_element);
   if (result != ASN1_SUCCESS)
     {
-      asn1_perror (result);
+      asn1_internal_perror (result);
       printf ("Cannot create PKCS12 element\n");
       exit (1);
     }
 
-  result = asn1_der_decoding (&asn1_element, buffer, size, errorDescription);
+  result = asn1_internal_der_decoding (&asn1_element, buffer, size, errorDescription);
   if (result != ASN1_SUCCESS)
     {
-      asn1_perror (result);
+      asn1_internal_perror (result);
       printf ("Cannot decode BER data (size %ld)\n", (long) size);
       exit (1);
     }
 
   /* Clear the definition structures */
-  asn1_delete_structure (&definitions);
-  asn1_delete_structure (&asn1_element);
+  asn1_internal_delete_structure (&definitions);
+  asn1_internal_delete_structure (&asn1_element);
 
   if (out != stdout)
     fclose (out);
